Dialog editing in Angular TreeGrid component

10 Sep 202524 minutes to read

Dialog editing is a feature in the TreeGrid component that allows you to edit data of the currently selected row using a dialog window. With dialog editing, you can modify cell values and save changes back to the data source. This feature is particularly beneficial when you need to quickly modify data without navigating to a separate page or view, streamlining the process of editing multiple cells.

To enable dialog editing in TreeGrid, set the editSettings.mode property to Dialog. This property determines the editing mode for the TreeGrid, and when set to Dialog, it enables the dialog editing feature.

The following example demonstrates how to enable dialog editing in the TreeGrid:

import { NgModule,ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService,EditService,ToolbarService } from '@syncfusion/ej2-angular-treegrid'

import { Component, OnInit } from '@angular/core';
import { sampleData } from './datasource';
import { EditSettingsModel, ToolbarItems } from '@syncfusion/ej2-angular-treegrid';

@Component({
    imports: [ TreeGridModule  ],

    providers: [PageService,
                SortService,
                FilterService,
                EditService,
                ToolbarService],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid [dataSource]='data'  [toolbar]='toolbarOptions' [treeColumnIndex]='1' height='270' [editSettings]='editSettings' childMapping='subtasks' >
                    <e-columns>
                        <e-column field='taskID' headerText='Task ID' [isPrimaryKey]='true' textAlign='Right' width=90></e-column>
                        <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                        <e-column field='priority' headerText='Priority' textAlign='Right' width=90></e-column>
                        <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' type='date' editType='datepickeredit' width=90></e-column>
                        <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                    </e-columns>
                </ejs-treegrid>`
})
export class AppComponent implements OnInit {

    public data?: Object[];
    public editSettings?: EditSettingsModel;
    public toolbarOptions?: ToolbarItems[];
    ngOnInit(): void {
        this.data = sampleData;
        this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Dialog' };
        this.toolbarOptions = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customize edit dialog

The edit dialog in the TreeGrid component allows you to customize its appearance and behavior based on the type of action being performed, such as editing or adding a record. You can modify properties like header text, close icon, and height to tailor the edit dialog to your specific requirements. Additionally, you can override default localization strings to provide custom text for buttons or other elements within the dialog.

To customize the edit dialog, handle the actionComplete event of the TreeGrid component and perform the necessary modifications based on the requestType parameter. The requestType parameter identifies the type of action being performed, such as beginEdit for editing a record or add for adding a new record.

You can refer the TreeGrid Default text list for more localization.

The following example demonstrates how to customize the edit dialog using the actionComplete event:

import { NgModule,ViewChild } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService,EditService,ToolbarService } from '@syncfusion/ej2-angular-treegrid'

import { L10n } from '@syncfusion/ej2-base';
import { Component, OnInit } from '@angular/core';
import { sampleData } from './datasource';
import { EditSettingsModel, ToolbarItems } from '@syncfusion/ej2-angular-treegrid';

L10n.load({
    'en-US': {
        treegrid: {
            'SaveButton': 'Submit',
            'CancelButton': 'Discard'
        }
    }
});

@Component({
    imports: [TreeGridModule],

    providers: [PageService,
                SortService,
                FilterService,
                EditService,
                ToolbarService],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid [dataSource]='data' [toolbar]='toolbarOptions' [treeColumnIndex]='1' height='270' [editSettings]='editSettings' (actionComplete)="actionComplete($event)" childMapping='subtasks' >
                    <e-columns>
                        <e-column field='taskID' headerText='Task ID' [isPrimaryKey]='true' textAlign='Right' width=90></e-column>
                        <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                        <e-column field='priority' headerText='Priority' textAlign='Right' width=90></e-column>
                        <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' type='date' editType='datepickeredit' width=90></e-column>
                        <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                    </e-columns>
                </ejs-treegrid>`
})
export class AppComponent implements OnInit {

    public data?: object[];
    public editSettings?: EditSettingsModel;
    public toolbarOptions?: ToolbarItems[];

    ngOnInit(): void {
        this.data = sampleData;
        this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Dialog' };
        this.toolbarOptions = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
    }

    actionComplete(args: any) {
        if ((args.requestType === 'beginEdit' || args.requestType === 'add')) {
            const dialog = args.dialog;
            const taskName = 'taskName';
            dialog.showCloseIcon = false;
            dialog.height = 400;
            // change the header of the dialog
            dialog.header = args.requestType === 'beginEdit' ? 'Edit Record of ' + args.rowData['taskName'] : 'New Task Details';
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The TreeGrid add or edit dialog element has the max-height property, which is calculated based on the available window height. So, in the normal window (1920 x 1080), it is possible to set the dialog height up to 658px.

Show or hide columns in dialog editing

The show or hide columns feature in dialog editing allows you to dynamically control column visibility while editing in dialog mode. This feature is useful when you want to display specific columns based on the type of action being performed, such as editing an existing record or adding a new record. To achieve this, utilize the actionBegin event of the TreeGrid.

The actionBegin event is triggered whenever an action is initiated in the TreeGrid, such as editing, adding, or deleting a record. Within the event handler, you can check the requestType parameter to determine the type of action being performed. If the requestType is beginEdit or add, you can modify column visibility using the column.visible property. This property determines whether a column should be displayed or hidden. When the requestType is save, you can reset column visibility to its initial state using the column.visible property.

In the following example, the TreeGrid columns priority is rendered as a hidden column and duration as a visible column. In edit mode, the priority column is changed to a visible state and duration column to a hidden state:

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService,EditService,ToolbarService } from '@syncfusion/ej2-angular-treegrid'

import { Component, OnInit, ViewChild } from '@angular/core';
import { sampleData } from './datasource';
import { EditSettingsModel, ToolbarItems, TreeGridComponent, Column } from '@syncfusion/ej2-angular-treegrid';
import { SaveEventArgs, EditEventArgs } from '@syncfusion/ej2-angular-grids';

@Component({
    imports: [TreeGridModule ],

    providers: [PageService,
                SortService,
                FilterService,
                EditService,
                ToolbarService],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid #treegrid [dataSource]='data' [toolbar]='toolbarOptions' [treeColumnIndex]='1' height='270' [editSettings]='editSettings' (actionComplete)="actionComplete($event)" (actionBegin)="actionBegin($event)" childMapping='subtasks'>
                    <e-columns>
                        <e-column field='taskID' headerText='Task ID' [isPrimaryKey]='true' textAlign='Right' width=90></e-column>
                        <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                        <e-column field='priority' headerText='Priority' [visible]='false' textAlign='Right' width=90></e-column>
                        <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' type='date' editType='datepickeredit' width=90></e-column>
                        <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                    </e-columns>
                </ejs-treegrid>`
})
export class AppComponent implements OnInit {

    public data?: object[];
    public editSettings?: EditSettingsModel;
    public toolbarOptions?: ToolbarItems[];
    @ViewChild('treegrid') treegrid?: TreeGridComponent;

    ngOnInit(): void {
        this.data = sampleData;
        this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Dialog' };
        this.toolbarOptions = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
    }

    actionBegin(args: EditEventArgs) {
        if ((args.requestType === 'beginEdit' || args.requestType === 'add')) {
            for (const cols of (this.treegrid as TreeGridComponent).grid.columns) {
                if ((cols as Column).field === 'priority') {
                    (cols as Column).visible = true;
                } else if ((cols as Column).field === 'duration') {
                    (cols as Column).visible = false;
                }
            }
        }
    }

    actionComplete(args: SaveEventArgs) {
        if (args.requestType === 'save') {
            for (const cols of (this.treegrid as TreeGridComponent).grid.columns) {
                if ((cols as Column).field === 'priority') {
                    (cols as Column).visible = false;
                } else if ((cols as Column).field === 'duration') {
                    (cols as Column).visible = true;
                }
            }
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Use wizard like dialog editing

Wizard-like dialog editing enables the creation of intuitive step-by-step forms. This feature provides a structured approach to form completion or data entry by breaking down the process into manageable steps. This feature is particularly useful for complex forms that need to be divided into smaller sections to streamline the data entry process.

To achieve wizard-like dialog editing in the TreeGrid component, use the dialog template feature. This feature allows you to define your own custom editing template using the editSettings.mode property set to Dialog and editSettingsTemplate as template variable in NgTemplate to define the TreeGrid editors for each step of the wizard.

The following example demonstrates the wizard-like editing in the TreeGrid with unobtrusive validation:

import { NgModule } from '@angular/core'
import { CommonModule } from '@angular/common';
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService,EditService,ToolbarService } from '@syncfusion/ej2-angular-treegrid'
import { CheckBoxAllModule, ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { DropDownListAllModule } from '@syncfusion/ej2-angular-dropdowns';
import { NumericTextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { Component, OnInit, ViewChild } from '@angular/core';
import { sampleData } from './datasource';
import { EditSettingsModel, ToolbarItems, TreeGridComponent, Column } from '@syncfusion/ej2-angular-treegrid';
import { SaveEventArgs, EditEventArgs } from '@syncfusion/ej2-angular-grids';
import { FormGroup, NgForm } from '@angular/forms';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';

@Component({
    imports: [TreeGridModule, CheckBoxAllModule, ButtonModule, DropDownListAllModule, 
            NumericTextBoxModule, CommonModule, ReactiveFormsModule, FormsModule,],

    providers: [PageService,
                SortService,
                FilterService,
                EditService,
                ToolbarService],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid #treegrid [dataSource]='data' [toolbar]='toolbarOptions' [treeColumnIndex]='1' height='270' [editSettings]='editSettings' (actionComplete)="actionComplete($event)" childMapping='subtasks'>
                    <e-columns>
                        <e-column field='taskID' headerText='Task ID' isPrimaryKey='true' textAlign='Right' width=90></e-column>
                        <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                        <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                        <e-column field='priority' headerText='Priority' textAlign='Right' width=90></e-column>
                        <e-column field='approved' headerText='approved' textAlign='Right' width=80 type="boolean" [displayAsCheckBox]="true"></e-column>
                    </e-columns>
                    <ng-template #editSettingsTemplate let-data>
                        <div ngForm #orderForm="ngForm" >
                            <div id="tab0" class="tab"  [hidden]="currentTab !== 0">
                             <!-- Tab 0 Content -->
                                <div class="form-row">
                                    <div class="form-group col-md-6">
                                    <div class="e-float-input e-control-wrapper" [ngClass]="{'e-error': taskID.invalid && (taskID.dirty || taskID.touched)}">
                                    <input [(ngModel)]="data.taskID" required id="taskID" name="taskID" type="text" [attr.disabled]="!data.isAdd ? '' : null" #taskID="ngModel">
                                    <span class="e-float-line"></span>
                                    <label class="e-float-text e-label-top" for="taskID"> Task ID</label>
                                </div>
                                <div id="taskIDError" *ngIf='taskID.invalid && (taskID.dirty || taskID.touched)'>
                                    <label class="e-error" id="taskID-info" style="display: block;">*Task ID is required</label>
                                </div>
                                    </div>
                                </div>
                                <div class="form-row">
                                    <div class="form-group col-md-6">
                                    <div class="e-float-input e-control-wrapper" [ngClass]="{'e-error': taskName.invalid && (taskName.dirty || taskName.touched)}">
                                    <input [(ngModel)]="data.taskName" required id="taskName" name="taskName" type="text" #taskName="ngModel">
                                    <span class="e-float-line"></span>
                                    <label class="e-float-text e-label-top" for="taskName">Task Name</label>
                                </div>
                                <div id="taskNameError" *ngIf='taskName.invalid && (taskName.dirty || taskName.touched)'>
                                    <label class="e-error" id="taskName-info" style="display: block;">*Task Name is required</label>
                                </div>
                                    </div>
                                </div>
                            </div>
                            <div id="tab1" class="tab" [hidden]="currentTab !== 1">
                                <!-- Tab 2 content -->
                                <div class="form-row">
                                    <div class="form-group col-md-6">
                                        <div class="e-float-input e-control-wrapper" [ngClass]="{'e-error': duration.invalid && (duration.dirty || duration.touched)}">
                                    <div>
                                    <label class="e-float-text e-label-top" for="duration">Duration</label>
                                </div>
                                <!-- Use ejs-numerictextbox for numeric input -->
                                    <ejs-numerictextbox style="margin-top:10px" (ngModel)="data.duration"  id="duration" name="duration" #duration="ngModel" floatLabelType= 'Always'></ejs-numerictextbox>
                                </div>
                                
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-group col-md-6">
                                <!-- Use ejs-dropdownlist for priority -->
                                <ejs-dropdownlist id="priority" name="priority" (ngModel)="data.priority" [dataSource]="priorityDistinctData" [fields]="{ text: 'priority', value: 'priority' }" placeholder="Ship City" popupHeight="300px" floatLabelType="Always"></ejs-dropdownlist>
                            </div>
                        </div>
                    </div>
      

                    <div id="tab2" class="tab" [hidden]="currentTab !== 2">
                        <!-- Tab 2 Content -->
                        
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <ejs-checkbox #approved name="approved" id="approved" label="approved" [checked]="data.approved"></ejs-checkbox>
                        </div>
                    </div>
                </div>
                <div id='footer'>
                    <div style="float: left;">
                        <button ejs-button type="button" cssClass="e-info e-btn" (click)="previousBtn()" id="btn" *ngIf="currentTab !== 0">Previous</button>
                            </div>
                                <div style="float: right;">
                                    <button ejs-button  style="margin-right:10px" type="button"  cssClass="e-info e-btn" (click)="saveBtn()" >Save</button>
                                    <button ejs-button  type="button" cssClass="e-info e-btn" (click)='nextBtn()' *ngIf="currentTab !== 2" id="btn" [disabled]="(taskName.invalid || taskID.invalid)">next</button>
                                </div>
                    </div>
                </div>
            </ng-template>
        </ejs-treegrid>`
})
export class AppComponent implements OnInit {

    public data?: object[];
    public editSettings?: EditSettingsModel;
    public toolbarOptions?: ToolbarItems[];
    public priorityDistinctData = ['Low', 'High', "Critical", 'Normal'];
    @ViewChild('treegrid') treegrid?: TreeGridComponent;
    public currentTab = 0;
    @ViewChild('orderForm') orderForm?: NgForm;

    ngOnInit(): void {
        this.data = sampleData;
        this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Dialog' };
        this.toolbarOptions = ['Add', 'Edit', 'Delete'];
    }

    actionComplete(args: any) {
        if ((args.requestType === 'beginEdit') || (args.requestType === 'add')) {
          (args as any).form.ej2_instances[0].rules = {}; // Disable default validation.
          (args.dialog as any).element.classList.add('hide-default-buttons');
          // Set initial Focus
          if (args.requestType === 'beginEdit') {
            (args?.form?.elements.namedItem('taskName') as HTMLInputElement).focus();
          }
          this.currentTab = 0;
        }
      }
      saveBtn() {
        if (this.orderForm?.valid ) {
          (this.treegrid as TreeGridComponent).endEdit();
        }
      }
    
      nextBtn() {
        if (this.orderForm?.valid ) {
          this.currentTab++;
          this.removeFocusFromButton()
        }
      }
    
      previousBtn() {
        if (this.orderForm?.valid) {
          this.currentTab--;
          this.removeFocusFromButton()
        }
      }
    
      removeFocusFromButton() {
        const nextButton = document.getElementById('btn') as HTMLButtonElement;
        if (nextButton) {
          nextButton.blur();
        }
      }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The customize add/edit dialog footer feature in the TreeGrid allows you to modify the footer section of the dialog that appears when editing the currently selected row or adding a new row. By default, the dialog displays two buttons in the footer section: Save and Cancel, which allow you to save or discard changes made in the dialog. This feature is particularly helpful when you want to add custom buttons to the dialog footer, implement specific actions, or customize button appearance, such as changing their color or size. This can be achieved using the actionComplete event of the TreeGrid component.

In the following example, using the dialog argument of the actionComplete event, the action for the custom button can be customized:

import { NgModule } from '@angular/core'
import { CommonModule } from '@angular/common';
import { TreeGridModule } from '@syncfusion/ej2-angular-treegrid'
import { PageService, SortService, FilterService,EditService,ToolbarService } from '@syncfusion/ej2-angular-treegrid'
import { Component, OnInit, ViewChild } from '@angular/core';
import { sampleData } from './datasource';
import { EditSettingsModel, ToolbarItems, TreeGridComponent, Column } from '@syncfusion/ej2-angular-treegrid';
import { SaveEventArgs, EditEventArgs } from '@syncfusion/ej2-angular-grids';


@Component({
    imports: [TreeGridModule],

    providers: [PageService,
                SortService,
                FilterService,
                EditService,
                ToolbarService],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-treegrid #treegrid [dataSource]='data' [toolbar]='toolbarOptions' [treeColumnIndex]='1' height='270' [editSettings]='editSettings' (actionComplete)="actionComplete($event)" childMapping='subtasks'>
                    <e-columns>
                        <e-column field='taskID' headerText='Task ID' isPrimaryKey='true' textAlign='Right' width=90></e-column>
                        <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
                        <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
                        <e-column field='priority' headerText='Priority' textAlign='Right' width=90></e-column>
                        <e-column field='approved' headerText='approved' textAlign='Right' width=80 type="boolean" [displayAsCheckBox]="true"></e-column>
                    </e-columns>
                </ejs-treegrid>`
})
export class AppComponent implements OnInit {

    public data?: object[];
    public editSettings?: EditSettingsModel;
    public toolbarOptions?: ToolbarItems[];
    public priorityDistinctData = ['Low', 'High', "Critical", 'Normal'];
    @ViewChild('treegrid') treegrid?: TreeGridComponent;
    

    ngOnInit(): void {
        this.data = sampleData;
        this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Dialog' };
        this.toolbarOptions = ['Add', 'Edit', 'Delete'];
    }
    actionComplete(args: EditEventArgs) {
        if (args.requestType === 'beginEdit' || args.requestType === 'add') {
          const dialogInstance = (args as any).dialog;
          dialogInstance.buttons = [
            {
                buttonModel: { content: 'Discard', cssClass: 'e-primary custom-button-style'  }, 
                click: () => {
                  (this.treegrid as TreeGridComponent).grid.editModule.closeEdit();
                }
              },
            {
              buttonModel: { content: 'Submit', cssClass: 'e-success custom-button-style' },
              click: () => {
                (this.treegrid as TreeGridComponent).grid.editModule.endEdit();
              }
            }
          ];
        }
      }

   }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Dialog editing in React Treegrid component

27 Jan 20234 minutes to read

In Dialog edit mode, when you start editing the currently selected row, data will be shown on a dialog. You can change the cell values and save edited data to the data source. To enable Dialog edit, set the editSettings.mode as Dialog.

import { ColumnDirective, ColumnsDirective, Inject, TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import { Edit, Toolbar } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import { sampleData } from './datasource';
function App() {
    const editOptions = {
        allowAdding: true,
        allowDeleting: true,
        allowEditing: true,
        mode: 'Dialog'
    };
    const toolbarOptions = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
    return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} childMapping='subtasks' height='270' editSettings={editOptions} toolbar={toolbarOptions}>
        <ColumnsDirective>
          <ColumnDirective field='taskID' headerText='Task ID' width='90' textAlign='Right' isPrimaryKey={true}/>
          <ColumnDirective field='taskName' headerText='Task Name' width='180'/>
          <ColumnDirective field='startDate' headerText='Start Date' width='130' format='yMd' textAlign='Right' type='date' editType='datepickeredit'/>
          <ColumnDirective field='duration' headerText='Duration' width='80' textAlign='Right'/>
        </ColumnsDirective>
        <Inject services={[Edit, Toolbar]}/>
    </TreeGridComponent>;
}
;
export default App;
import { ColumnDirective, ColumnsDirective, Inject, TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
import { Edit, EditSettingsModel, Toolbar, ToolbarItems } from '@syncfusion/ej2-react-treegrid';
import * as React from 'react';
import { sampleData } from './datasource';

function App() {
    const editOptions: EditSettingsModel = {
        allowAdding: true,
        allowDeleting: true,
        allowEditing: true,
        mode: 'Dialog'
    };
    const toolbarOptions: ToolbarItems[] = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
    return <TreeGridComponent dataSource={sampleData} treeColumnIndex={1} childMapping='subtasks'
      height='270' editSettings={editOptions} toolbar={toolbarOptions}>
        <ColumnsDirective>
          <ColumnDirective field='taskID' headerText='Task ID' width='90' textAlign='Right' isPrimaryKey={true}/>
          <ColumnDirective field='taskName' headerText='Task Name' width='180'/>
          <ColumnDirective field='startDate' headerText='Start Date' width='130' format='yMd' textAlign='Right' type='date' editType='datepickeredit' />
          <ColumnDirective field='duration' headerText='Duration' width='80' textAlign='Right' />
        </ColumnsDirective>
        <Inject services={[Edit, Toolbar]}/>
    </TreeGridComponent>
};
export default App;

Dialog editing in Vue Treegrid component

7 Jun 20244 minutes to read

In Dialog edit mode, when you start editing the currently selected row, data will be shown on a dialog. You can change the cell values and save edited data to the data source.

To enable Dialog edit, set the editSettings.mode as Dialog.

<template>
<div id="app">
        <ejs-treegrid ref='treegrid' :dataSource='data' childMapping='subtasks' :treeColumnIndex='1' height='270px' :editSettings='editSettings' :toolbar='toolbar'>
        <e-columns>
                <e-column field='taskID'  :isPrimaryKey='true'  headerText='Task ID'  width=90 textAlign='Right'></e-column>
                <e-column field='taskName' headerText='Task Name' width=180></e-column>
                <e-column field='startDate' headerText='Start Date' editType= 'datepickeredit' type= 'date' format= 'yMd' textAlign='Right' width=170></e-column>
                <e-column field='duration' headerText='Duration' width=80  textAlign='Right'></e-column>
                </e-columns>
        </ejs-treegrid>
</div>
</template>
<script setup>
import { provide } from "vue";

import { TreeGridComponent as EjsTreegrid, Edit, Toolbar, ColumnDirective as EColumn, ColumnsDirective as EColumns } from "@syncfusion/ej2-vue-treegrid";
import { sampleData } from "./datasource.js";

const data = sampleData;

const toolbar = ['Add', 'Delete', 'Update', 'Cancel'];

const editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Dialog' };

provide('treegrid',  [ Edit, Toolbar ]);

</script>
<template>
<div id="app">
        <ejs-treegrid ref='treegrid' :dataSource='data' childMapping='subtasks' :treeColumnIndex='1' height='270px' :editSettings='editSettings' :toolbar='toolbar'>
        <e-columns>
                <e-column field='taskID'  :isPrimaryKey='true'  headerText='Task ID'  width=90 textAlign='Right'></e-column>
                <e-column field='taskName' headerText='Task Name' width=180></e-column>
                <e-column field='startDate' headerText='Start Date' editType= 'datepickeredit' type= 'date' format= 'yMd' textAlign='Right' width=170></e-column>
                <e-column field='duration' headerText='Duration' width=80  textAlign='Right'></e-column>
                </e-columns>
        </ejs-treegrid>
</div>
</template>
<script>

import { TreeGridComponent, Edit, Toolbar, ColumnDirective, ColumnsDirective } from "@syncfusion/ej2-vue-treegrid";
import { sampleData } from "./datasource.js";

export default {
name: "App",
components: {
"ejs-treegrid":TreeGridComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective,

},

  data() {
    return {
      data: sampleData,
      toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
      editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Dialog' },
    };
  },
    provide: {
    treegrid: [ Edit, Toolbar ]
  }
}
</script>